/* Automatically generated nanopb header */
/* Generated by nanopb-0.4.0-dev at Tue Oct  9 15:58:33 2018. */

#ifndef PB_GOOGLE_PROTOBUF_DESCRIPTOR_PB_H_INCLUDED
#define PB_GOOGLE_PROTOBUF_DESCRIPTOR_PB_H_INCLUDED
#include <pb.h>

/* @@protoc_insertion_point(includes) */
#if PB_PROTO_HEADER_VERSION != 30
#error Regenerate this file with the current version of nanopb generator.
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* Enum definitions */
typedef enum _google_protobuf_FieldDescriptorProto_Type {
    google_protobuf_FieldDescriptorProto_Type_TYPE_DOUBLE = 1,
    google_protobuf_FieldDescriptorProto_Type_TYPE_FLOAT = 2,
    google_protobuf_FieldDescriptorProto_Type_TYPE_INT64 = 3,
    google_protobuf_FieldDescriptorProto_Type_TYPE_UINT64 = 4,
    google_protobuf_FieldDescriptorProto_Type_TYPE_INT32 = 5,
    google_protobuf_FieldDescriptorProto_Type_TYPE_FIXED64 = 6,
    google_protobuf_FieldDescriptorProto_Type_TYPE_FIXED32 = 7,
    google_protobuf_FieldDescriptorProto_Type_TYPE_BOOL = 8,
    google_protobuf_FieldDescriptorProto_Type_TYPE_STRING = 9,
    google_protobuf_FieldDescriptorProto_Type_TYPE_GROUP = 10,
    google_protobuf_FieldDescriptorProto_Type_TYPE_MESSAGE = 11,
    google_protobuf_FieldDescriptorProto_Type_TYPE_BYTES = 12,
    google_protobuf_FieldDescriptorProto_Type_TYPE_UINT32 = 13,
    google_protobuf_FieldDescriptorProto_Type_TYPE_ENUM = 14,
    google_protobuf_FieldDescriptorProto_Type_TYPE_SFIXED32 = 15,
    google_protobuf_FieldDescriptorProto_Type_TYPE_SFIXED64 = 16,
    google_protobuf_FieldDescriptorProto_Type_TYPE_SINT32 = 17,
    google_protobuf_FieldDescriptorProto_Type_TYPE_SINT64 = 18
} google_protobuf_FieldDescriptorProto_Type;
#define _google_protobuf_FieldDescriptorProto_Type_MIN google_protobuf_FieldDescriptorProto_Type_TYPE_DOUBLE
#define _google_protobuf_FieldDescriptorProto_Type_MAX google_protobuf_FieldDescriptorProto_Type_TYPE_SINT64
#define _google_protobuf_FieldDescriptorProto_Type_ARRAYSIZE ((google_protobuf_FieldDescriptorProto_Type)(google_protobuf_FieldDescriptorProto_Type_TYPE_SINT64+1))

typedef enum _google_protobuf_FieldDescriptorProto_Label {
    google_protobuf_FieldDescriptorProto_Label_LABEL_OPTIONAL = 1,
    google_protobuf_FieldDescriptorProto_Label_LABEL_REQUIRED = 2,
    google_protobuf_FieldDescriptorProto_Label_LABEL_REPEATED = 3
} google_protobuf_FieldDescriptorProto_Label;
#define _google_protobuf_FieldDescriptorProto_Label_MIN google_protobuf_FieldDescriptorProto_Label_LABEL_OPTIONAL
#define _google_protobuf_FieldDescriptorProto_Label_MAX google_protobuf_FieldDescriptorProto_Label_LABEL_REPEATED
#define _google_protobuf_FieldDescriptorProto_Label_ARRAYSIZE ((google_protobuf_FieldDescriptorProto_Label)(google_protobuf_FieldDescriptorProto_Label_LABEL_REPEATED+1))

typedef enum _google_protobuf_FileOptions_OptimizeMode {
    google_protobuf_FileOptions_OptimizeMode_SPEED = 1,
    google_protobuf_FileOptions_OptimizeMode_CODE_SIZE = 2,
    google_protobuf_FileOptions_OptimizeMode_LITE_RUNTIME = 3
} google_protobuf_FileOptions_OptimizeMode;
#define _google_protobuf_FileOptions_OptimizeMode_MIN google_protobuf_FileOptions_OptimizeMode_SPEED
#define _google_protobuf_FileOptions_OptimizeMode_MAX google_protobuf_FileOptions_OptimizeMode_LITE_RUNTIME
#define _google_protobuf_FileOptions_OptimizeMode_ARRAYSIZE ((google_protobuf_FileOptions_OptimizeMode)(google_protobuf_FileOptions_OptimizeMode_LITE_RUNTIME+1))

typedef enum _google_protobuf_FieldOptions_CType {
    google_protobuf_FieldOptions_CType_STRING = 0,
    google_protobuf_FieldOptions_CType_CORD = 1,
    google_protobuf_FieldOptions_CType_STRING_PIECE = 2
} google_protobuf_FieldOptions_CType;
#define _google_protobuf_FieldOptions_CType_MIN google_protobuf_FieldOptions_CType_STRING
#define _google_protobuf_FieldOptions_CType_MAX google_protobuf_FieldOptions_CType_STRING_PIECE
#define _google_protobuf_FieldOptions_CType_ARRAYSIZE ((google_protobuf_FieldOptions_CType)(google_protobuf_FieldOptions_CType_STRING_PIECE+1))

typedef enum _google_protobuf_FieldOptions_JSType {
    google_protobuf_FieldOptions_JSType_JS_NORMAL = 0,
    google_protobuf_FieldOptions_JSType_JS_STRING = 1,
    google_protobuf_FieldOptions_JSType_JS_NUMBER = 2
} google_protobuf_FieldOptions_JSType;
#define _google_protobuf_FieldOptions_JSType_MIN google_protobuf_FieldOptions_JSType_JS_NORMAL
#define _google_protobuf_FieldOptions_JSType_MAX google_protobuf_FieldOptions_JSType_JS_NUMBER
#define _google_protobuf_FieldOptions_JSType_ARRAYSIZE ((google_protobuf_FieldOptions_JSType)(google_protobuf_FieldOptions_JSType_JS_NUMBER+1))

typedef enum _google_protobuf_MethodOptions_IdempotencyLevel {
    google_protobuf_MethodOptions_IdempotencyLevel_IDEMPOTENCY_UNKNOWN = 0,
    google_protobuf_MethodOptions_IdempotencyLevel_NO_SIDE_EFFECTS = 1,
    google_protobuf_MethodOptions_IdempotencyLevel_IDEMPOTENT = 2
} google_protobuf_MethodOptions_IdempotencyLevel;
#define _google_protobuf_MethodOptions_IdempotencyLevel_MIN google_protobuf_MethodOptions_IdempotencyLevel_IDEMPOTENCY_UNKNOWN
#define _google_protobuf_MethodOptions_IdempotencyLevel_MAX google_protobuf_MethodOptions_IdempotencyLevel_IDEMPOTENT
#define _google_protobuf_MethodOptions_IdempotencyLevel_ARRAYSIZE ((google_protobuf_MethodOptions_IdempotencyLevel)(google_protobuf_MethodOptions_IdempotencyLevel_IDEMPOTENT+1))

/* Struct definitions */
typedef struct _google_protobuf_ExtensionRangeOptions {
    pb_callback_t uninterpreted_option;
    pb_extension_t *extensions;
/* @@protoc_insertion_point(struct:google_protobuf_ExtensionRangeOptions) */
} google_protobuf_ExtensionRangeOptions;

typedef struct _google_protobuf_FileDescriptorSet {
    pb_callback_t file;
/* @@protoc_insertion_point(struct:google_protobuf_FileDescriptorSet) */
} google_protobuf_FileDescriptorSet;

typedef struct _google_protobuf_GeneratedCodeInfo {
    pb_callback_t annotation;
/* @@protoc_insertion_point(struct:google_protobuf_GeneratedCodeInfo) */
} google_protobuf_GeneratedCodeInfo;

typedef struct _google_protobuf_OneofOptions {
    pb_callback_t uninterpreted_option;
    pb_extension_t *extensions;
/* @@protoc_insertion_point(struct:google_protobuf_OneofOptions) */
} google_protobuf_OneofOptions;

typedef struct _google_protobuf_SourceCodeInfo {
    pb_callback_t location;
/* @@protoc_insertion_point(struct:google_protobuf_SourceCodeInfo) */
} google_protobuf_SourceCodeInfo;

typedef struct _google_protobuf_SourceCodeInfo_Location {
    pb_callback_t path;
    pb_callback_t span;
    pb_callback_t leading_comments;
    pb_callback_t trailing_comments;
    pb_callback_t leading_detached_comments;
/* @@protoc_insertion_point(struct:google_protobuf_SourceCodeInfo_Location) */
} google_protobuf_SourceCodeInfo_Location;

typedef struct _google_protobuf_DescriptorProto_ExtensionRange {
    bool has_start;
    int32_t start;
    bool has_end;
    int32_t end;
    bool has_options;
    google_protobuf_ExtensionRangeOptions options;
/* @@protoc_insertion_point(struct:google_protobuf_DescriptorProto_ExtensionRange) */
} google_protobuf_DescriptorProto_ExtensionRange;

typedef struct _google_protobuf_DescriptorProto_ReservedRange {
    bool has_start;
    int32_t start;
    bool has_end;
    int32_t end;
/* @@protoc_insertion_point(struct:google_protobuf_DescriptorProto_ReservedRange) */
} google_protobuf_DescriptorProto_ReservedRange;

typedef struct _google_protobuf_EnumDescriptorProto_EnumReservedRange {
    bool has_start;
    int32_t start;
    bool has_end;
    int32_t end;
/* @@protoc_insertion_point(struct:google_protobuf_EnumDescriptorProto_EnumReservedRange) */
} google_protobuf_EnumDescriptorProto_EnumReservedRange;

typedef struct _google_protobuf_EnumOptions {
    bool has_allow_alias;
    bool allow_alias;
    bool has_deprecated;
    bool deprecated;
    pb_callback_t uninterpreted_option;
    pb_extension_t *extensions;
/* @@protoc_insertion_point(struct:google_protobuf_EnumOptions) */
} google_protobuf_EnumOptions;

typedef struct _google_protobuf_EnumValueOptions {
    bool has_deprecated;
    bool deprecated;
    pb_callback_t uninterpreted_option;
    pb_extension_t *extensions;
/* @@protoc_insertion_point(struct:google_protobuf_EnumValueOptions) */
} google_protobuf_EnumValueOptions;

typedef struct _google_protobuf_FieldOptions {
    bool has_ctype;
    google_protobuf_FieldOptions_CType ctype;
    bool has_packed;
    bool packed;
    bool has_deprecated;
    bool deprecated;
    bool has_lazy;
    bool lazy;
    bool has_jstype;
    google_protobuf_FieldOptions_JSType jstype;
    bool has_weak;
    bool weak;
    pb_callback_t uninterpreted_option;
    pb_extension_t *extensions;
/* @@protoc_insertion_point(struct:google_protobuf_FieldOptions) */
} google_protobuf_FieldOptions;

typedef struct _google_protobuf_FileOptions {
    pb_callback_t java_package;
    pb_callback_t java_outer_classname;
    bool has_optimize_for;
    google_protobuf_FileOptions_OptimizeMode optimize_for;
    bool has_java_multiple_files;
    bool java_multiple_files;
    pb_callback_t go_package;
    bool has_cc_generic_services;
    bool cc_generic_services;
    bool has_java_generic_services;
    bool java_generic_services;
    bool has_py_generic_services;
    bool py_generic_services;
    bool has_java_generate_equals_and_hash;
    bool java_generate_equals_and_hash;
    bool has_deprecated;
    bool deprecated;
    bool has_java_string_check_utf8;
    bool java_string_check_utf8;
    bool has_cc_enable_arenas;
    bool cc_enable_arenas;
    pb_callback_t objc_class_prefix;
    pb_callback_t csharp_namespace;
    pb_callback_t swift_prefix;
    pb_callback_t php_class_prefix;
    pb_callback_t php_namespace;
    bool has_php_generic_services;
    bool php_generic_services;
    pb_callback_t php_metadata_namespace;
    pb_callback_t ruby_package;
    pb_callback_t uninterpreted_option;
    pb_extension_t *extensions;
/* @@protoc_insertion_point(struct:google_protobuf_FileOptions) */
} google_protobuf_FileOptions;

typedef struct _google_protobuf_GeneratedCodeInfo_Annotation {
    pb_callback_t path;
    pb_callback_t source_file;
    bool has_begin;
    int32_t begin;
    bool has_end;
    int32_t end;
/* @@protoc_insertion_point(struct:google_protobuf_GeneratedCodeInfo_Annotation) */
} google_protobuf_GeneratedCodeInfo_Annotation;

typedef struct _google_protobuf_MessageOptions {
    bool has_message_set_wire_format;
    bool message_set_wire_format;
    bool has_no_standard_descriptor_accessor;
    bool no_standard_descriptor_accessor;
    bool has_deprecated;
    bool deprecated;
    bool has_map_entry;
    bool map_entry;
    pb_callback_t uninterpreted_option;
    pb_extension_t *extensions;
/* @@protoc_insertion_point(struct:google_protobuf_MessageOptions) */
} google_protobuf_MessageOptions;

typedef struct _google_protobuf_MethodOptions {
    bool has_deprecated;
    bool deprecated;
    bool has_idempotency_level;
    google_protobuf_MethodOptions_IdempotencyLevel idempotency_level;
    pb_callback_t uninterpreted_option;
    pb_extension_t *extensions;
/* @@protoc_insertion_point(struct:google_protobuf_MethodOptions) */
} google_protobuf_MethodOptions;

typedef struct _google_protobuf_OneofDescriptorProto {
    pb_callback_t name;
    bool has_options;
    google_protobuf_OneofOptions options;
/* @@protoc_insertion_point(struct:google_protobuf_OneofDescriptorProto) */
} google_protobuf_OneofDescriptorProto;

typedef struct _google_protobuf_ServiceOptions {
    bool has_deprecated;
    bool deprecated;
    pb_callback_t uninterpreted_option;
    pb_extension_t *extensions;
/* @@protoc_insertion_point(struct:google_protobuf_ServiceOptions) */
} google_protobuf_ServiceOptions;

typedef struct _google_protobuf_UninterpretedOption {
    pb_callback_t name;
    pb_callback_t identifier_value;
    bool has_positive_int_value;
    uint64_t positive_int_value;
    bool has_negative_int_value;
    int64_t negative_int_value;
    bool has_double_value;
    double double_value;
    pb_callback_t string_value;
    pb_callback_t aggregate_value;
/* @@protoc_insertion_point(struct:google_protobuf_UninterpretedOption) */
} google_protobuf_UninterpretedOption;

typedef struct _google_protobuf_UninterpretedOption_NamePart {
    pb_callback_t name_part;
    bool is_extension;
/* @@protoc_insertion_point(struct:google_protobuf_UninterpretedOption_NamePart) */
} google_protobuf_UninterpretedOption_NamePart;

typedef struct _google_protobuf_DescriptorProto {
    pb_callback_t name;
    pb_callback_t field;
    pb_callback_t nested_type;
    pb_callback_t enum_type;
    pb_callback_t extension_range;
    pb_callback_t extension;
    bool has_options;
    google_protobuf_MessageOptions options;
    pb_callback_t oneof_decl;
    pb_callback_t reserved_range;
    pb_callback_t reserved_name;
/* @@protoc_insertion_point(struct:google_protobuf_DescriptorProto) */
} google_protobuf_DescriptorProto;

typedef struct _google_protobuf_EnumDescriptorProto {
    pb_callback_t name;
    pb_callback_t value;
    bool has_options;
    google_protobuf_EnumOptions options;
    pb_callback_t reserved_range;
    pb_callback_t reserved_name;
/* @@protoc_insertion_point(struct:google_protobuf_EnumDescriptorProto) */
} google_protobuf_EnumDescriptorProto;

typedef struct _google_protobuf_EnumValueDescriptorProto {
    pb_callback_t name;
    bool has_number;
    int32_t number;
    bool has_options;
    google_protobuf_EnumValueOptions options;
/* @@protoc_insertion_point(struct:google_protobuf_EnumValueDescriptorProto) */
} google_protobuf_EnumValueDescriptorProto;

typedef struct _google_protobuf_FieldDescriptorProto {
    pb_callback_t name;
    pb_callback_t extendee;
    bool has_number;
    int32_t number;
    bool has_label;
    google_protobuf_FieldDescriptorProto_Label label;
    bool has_type;
    google_protobuf_FieldDescriptorProto_Type type;
    pb_callback_t type_name;
    pb_callback_t default_value;
    bool has_options;
    google_protobuf_FieldOptions options;
    bool has_oneof_index;
    int32_t oneof_index;
    pb_callback_t json_name;
/* @@protoc_insertion_point(struct:google_protobuf_FieldDescriptorProto) */
} google_protobuf_FieldDescriptorProto;

typedef struct _google_protobuf_FileDescriptorProto {
    pb_callback_t name;
    pb_callback_t package;
    pb_callback_t dependency;
    pb_callback_t message_type;
    pb_callback_t enum_type;
    pb_callback_t service;
    pb_callback_t extension;
    bool has_options;
    google_protobuf_FileOptions options;
    bool has_source_code_info;
    google_protobuf_SourceCodeInfo source_code_info;
    pb_callback_t public_dependency;
    pb_callback_t weak_dependency;
    pb_callback_t syntax;
/* @@protoc_insertion_point(struct:google_protobuf_FileDescriptorProto) */
} google_protobuf_FileDescriptorProto;

typedef struct _google_protobuf_MethodDescriptorProto {
    pb_callback_t name;
    pb_callback_t input_type;
    pb_callback_t output_type;
    bool has_options;
    google_protobuf_MethodOptions options;
    bool has_client_streaming;
    bool client_streaming;
    bool has_server_streaming;
    bool server_streaming;
/* @@protoc_insertion_point(struct:google_protobuf_MethodDescriptorProto) */
} google_protobuf_MethodDescriptorProto;

typedef struct _google_protobuf_ServiceDescriptorProto {
    pb_callback_t name;
    pb_callback_t method;
    bool has_options;
    google_protobuf_ServiceOptions options;
/* @@protoc_insertion_point(struct:google_protobuf_ServiceDescriptorProto) */
} google_protobuf_ServiceDescriptorProto;

/* Default values for struct fields */
extern const bool google_protobuf_MethodDescriptorProto_client_streaming_default;
extern const bool google_protobuf_MethodDescriptorProto_server_streaming_default;
extern const bool google_protobuf_FileOptions_java_multiple_files_default;
extern const bool google_protobuf_FileOptions_java_string_check_utf8_default;
extern const google_protobuf_FileOptions_OptimizeMode google_protobuf_FileOptions_optimize_for_default;
extern const bool google_protobuf_FileOptions_cc_generic_services_default;
extern const bool google_protobuf_FileOptions_java_generic_services_default;
extern const bool google_protobuf_FileOptions_py_generic_services_default;
extern const bool google_protobuf_FileOptions_php_generic_services_default;
extern const bool google_protobuf_FileOptions_deprecated_default;
extern const bool google_protobuf_FileOptions_cc_enable_arenas_default;
extern const bool google_protobuf_MessageOptions_message_set_wire_format_default;
extern const bool google_protobuf_MessageOptions_no_standard_descriptor_accessor_default;
extern const bool google_protobuf_MessageOptions_deprecated_default;
extern const google_protobuf_FieldOptions_CType google_protobuf_FieldOptions_ctype_default;
extern const google_protobuf_FieldOptions_JSType google_protobuf_FieldOptions_jstype_default;
extern const bool google_protobuf_FieldOptions_lazy_default;
extern const bool google_protobuf_FieldOptions_deprecated_default;
extern const bool google_protobuf_FieldOptions_weak_default;
extern const bool google_protobuf_EnumOptions_deprecated_default;
extern const bool google_protobuf_EnumValueOptions_deprecated_default;
extern const bool google_protobuf_ServiceOptions_deprecated_default;
extern const bool google_protobuf_MethodOptions_deprecated_default;
extern const google_protobuf_MethodOptions_IdempotencyLevel google_protobuf_MethodOptions_idempotency_level_default;

/* Initializer values for message structs */
#define google_protobuf_FileDescriptorSet_init_default {{{NULL}, NULL}}
#define google_protobuf_FileDescriptorProto_init_default {{{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, false, google_protobuf_FileOptions_init_default, false, google_protobuf_SourceCodeInfo_init_default, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}}
#define google_protobuf_DescriptorProto_init_default {{{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, false, google_protobuf_MessageOptions_init_default, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}}
#define google_protobuf_DescriptorProto_ExtensionRange_init_default {false, 0, false, 0, false, google_protobuf_ExtensionRangeOptions_init_default}
#define google_protobuf_DescriptorProto_ReservedRange_init_default {false, 0, false, 0}
#define google_protobuf_ExtensionRangeOptions_init_default {{{NULL}, NULL}, NULL}
#define google_protobuf_FieldDescriptorProto_init_default {{{NULL}, NULL}, {{NULL}, NULL}, false, 0, false, _google_protobuf_FieldDescriptorProto_Label_MIN, false, _google_protobuf_FieldDescriptorProto_Type_MIN, {{NULL}, NULL}, {{NULL}, NULL}, false, google_protobuf_FieldOptions_init_default, false, 0, {{NULL}, NULL}}
#define google_protobuf_OneofDescriptorProto_init_default {{{NULL}, NULL}, false, google_protobuf_OneofOptions_init_default}
#define google_protobuf_EnumDescriptorProto_init_default {{{NULL}, NULL}, {{NULL}, NULL}, false, google_protobuf_EnumOptions_init_default, {{NULL}, NULL}, {{NULL}, NULL}}
#define google_protobuf_EnumDescriptorProto_EnumReservedRange_init_default {false, 0, false, 0}
#define google_protobuf_EnumValueDescriptorProto_init_default {{{NULL}, NULL}, false, 0, false, google_protobuf_EnumValueOptions_init_default}
#define google_protobuf_ServiceDescriptorProto_init_default {{{NULL}, NULL}, {{NULL}, NULL}, false, google_protobuf_ServiceOptions_init_default}
#define google_protobuf_MethodDescriptorProto_init_default {{{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, false, google_protobuf_MethodOptions_init_default, false, false, false, false}
#define google_protobuf_FileOptions_init_default {{{NULL}, NULL}, {{NULL}, NULL}, false, google_protobuf_FileOptions_OptimizeMode_SPEED, false, false, {{NULL}, NULL}, false, false, false, false, false, false, false, 0, false, false, false, false, false, false, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, false, false, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, NULL}
#define google_protobuf_MessageOptions_init_default {false, false, false, false, false, false, false, 0, {{NULL}, NULL}, NULL}
#define google_protobuf_FieldOptions_init_default {false, google_protobuf_FieldOptions_CType_STRING, false, 0, false, false, false, false, false, google_protobuf_FieldOptions_JSType_JS_NORMAL, false, false, {{NULL}, NULL}, NULL}
#define google_protobuf_OneofOptions_init_default {{{NULL}, NULL}, NULL}
#define google_protobuf_EnumOptions_init_default {false, 0, false, false, {{NULL}, NULL}, NULL}
#define google_protobuf_EnumValueOptions_init_default {false, false, {{NULL}, NULL}, NULL}
#define google_protobuf_ServiceOptions_init_default {false, false, {{NULL}, NULL}, NULL}
#define google_protobuf_MethodOptions_init_default {false, false, false, google_protobuf_MethodOptions_IdempotencyLevel_IDEMPOTENCY_UNKNOWN, {{NULL}, NULL}, NULL}
#define google_protobuf_UninterpretedOption_init_default {{{NULL}, NULL}, {{NULL}, NULL}, false, 0, false, 0, false, 0, {{NULL}, NULL}, {{NULL}, NULL}}
#define google_protobuf_UninterpretedOption_NamePart_init_default {{{NULL}, NULL}, 0}
#define google_protobuf_SourceCodeInfo_init_default {{{NULL}, NULL}}
#define google_protobuf_SourceCodeInfo_Location_init_default {{{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}}
#define google_protobuf_GeneratedCodeInfo_init_default {{{NULL}, NULL}}
#define google_protobuf_GeneratedCodeInfo_Annotation_init_default {{{NULL}, NULL}, {{NULL}, NULL}, false, 0, false, 0}
#define google_protobuf_FileDescriptorSet_init_zero {{{NULL}, NULL}}
#define google_protobuf_FileDescriptorProto_init_zero {{{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, false, google_protobuf_FileOptions_init_zero, false, google_protobuf_SourceCodeInfo_init_zero, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}}
#define google_protobuf_DescriptorProto_init_zero {{{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, false, google_protobuf_MessageOptions_init_zero, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}}
#define google_protobuf_DescriptorProto_ExtensionRange_init_zero {false, 0, false, 0, false, google_protobuf_ExtensionRangeOptions_init_zero}
#define google_protobuf_DescriptorProto_ReservedRange_init_zero {false, 0, false, 0}
#define google_protobuf_ExtensionRangeOptions_init_zero {{{NULL}, NULL}, NULL}
#define google_protobuf_FieldDescriptorProto_init_zero {{{NULL}, NULL}, {{NULL}, NULL}, false, 0, false, _google_protobuf_FieldDescriptorProto_Label_MIN, false, _google_protobuf_FieldDescriptorProto_Type_MIN, {{NULL}, NULL}, {{NULL}, NULL}, false, google_protobuf_FieldOptions_init_zero, false, 0, {{NULL}, NULL}}
#define google_protobuf_OneofDescriptorProto_init_zero {{{NULL}, NULL}, false, google_protobuf_OneofOptions_init_zero}
#define google_protobuf_EnumDescriptorProto_init_zero {{{NULL}, NULL}, {{NULL}, NULL}, false, google_protobuf_EnumOptions_init_zero, {{NULL}, NULL}, {{NULL}, NULL}}
#define google_protobuf_EnumDescriptorProto_EnumReservedRange_init_zero {false, 0, false, 0}
#define google_protobuf_EnumValueDescriptorProto_init_zero {{{NULL}, NULL}, false, 0, false, google_protobuf_EnumValueOptions_init_zero}
#define google_protobuf_ServiceDescriptorProto_init_zero {{{NULL}, NULL}, {{NULL}, NULL}, false, google_protobuf_ServiceOptions_init_zero}
#define google_protobuf_MethodDescriptorProto_init_zero {{{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, false, google_protobuf_MethodOptions_init_zero, false, 0, false, 0}
#define google_protobuf_FileOptions_init_zero    {{{NULL}, NULL}, {{NULL}, NULL}, false, _google_protobuf_FileOptions_OptimizeMode_MIN, false, 0, {{NULL}, NULL}, false, 0, false, 0, false, 0, false, 0, false, 0, false, 0, false, 0, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, false, 0, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, NULL}
#define google_protobuf_MessageOptions_init_zero {false, 0, false, 0, false, 0, false, 0, {{NULL}, NULL}, NULL}
#define google_protobuf_FieldOptions_init_zero   {false, _google_protobuf_FieldOptions_CType_MIN, false, 0, false, 0, false, 0, false, _google_protobuf_FieldOptions_JSType_MIN, false, 0, {{NULL}, NULL}, NULL}
#define google_protobuf_OneofOptions_init_zero   {{{NULL}, NULL}, NULL}
#define google_protobuf_EnumOptions_init_zero    {false, 0, false, 0, {{NULL}, NULL}, NULL}
#define google_protobuf_EnumValueOptions_init_zero {false, 0, {{NULL}, NULL}, NULL}
#define google_protobuf_ServiceOptions_init_zero {false, 0, {{NULL}, NULL}, NULL}
#define google_protobuf_MethodOptions_init_zero  {false, 0, false, _google_protobuf_MethodOptions_IdempotencyLevel_MIN, {{NULL}, NULL}, NULL}
#define google_protobuf_UninterpretedOption_init_zero {{{NULL}, NULL}, {{NULL}, NULL}, false, 0, false, 0, false, 0, {{NULL}, NULL}, {{NULL}, NULL}}
#define google_protobuf_UninterpretedOption_NamePart_init_zero {{{NULL}, NULL}, 0}
#define google_protobuf_SourceCodeInfo_init_zero {{{NULL}, NULL}}
#define google_protobuf_SourceCodeInfo_Location_init_zero {{{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}}
#define google_protobuf_GeneratedCodeInfo_init_zero {{{NULL}, NULL}}
#define google_protobuf_GeneratedCodeInfo_Annotation_init_zero {{{NULL}, NULL}, {{NULL}, NULL}, false, 0, false, 0}

/* Field tags (for use in manual encoding/decoding) */
#define google_protobuf_ExtensionRangeOptions_uninterpreted_option_tag 999
#define google_protobuf_FileDescriptorSet_file_tag 1
#define google_protobuf_GeneratedCodeInfo_annotation_tag 1
#define google_protobuf_OneofOptions_uninterpreted_option_tag 999
#define google_protobuf_SourceCodeInfo_location_tag 1
#define google_protobuf_SourceCodeInfo_Location_path_tag 1
#define google_protobuf_SourceCodeInfo_Location_span_tag 2
#define google_protobuf_SourceCodeInfo_Location_leading_comments_tag 3
#define google_protobuf_SourceCodeInfo_Location_trailing_comments_tag 4
#define google_protobuf_SourceCodeInfo_Location_leading_detached_comments_tag 6
#define google_protobuf_DescriptorProto_ExtensionRange_start_tag 1
#define google_protobuf_DescriptorProto_ExtensionRange_end_tag 2
#define google_protobuf_DescriptorProto_ExtensionRange_options_tag 3
#define google_protobuf_DescriptorProto_ReservedRange_start_tag 1
#define google_protobuf_DescriptorProto_ReservedRange_end_tag 2
#define google_protobuf_EnumDescriptorProto_EnumReservedRange_start_tag 1
#define google_protobuf_EnumDescriptorProto_EnumReservedRange_end_tag 2
#define google_protobuf_EnumOptions_allow_alias_tag 2
#define google_protobuf_EnumOptions_deprecated_tag 3
#define google_protobuf_EnumOptions_uninterpreted_option_tag 999
#define google_protobuf_EnumValueOptions_deprecated_tag 1
#define google_protobuf_EnumValueOptions_uninterpreted_option_tag 999
#define google_protobuf_FieldOptions_ctype_tag   1
#define google_protobuf_FieldOptions_packed_tag  2
#define google_protobuf_FieldOptions_jstype_tag  6
#define google_protobuf_FieldOptions_lazy_tag    5
#define google_protobuf_FieldOptions_deprecated_tag 3
#define google_protobuf_FieldOptions_weak_tag    10
#define google_protobuf_FieldOptions_uninterpreted_option_tag 999
#define google_protobuf_FileOptions_java_package_tag 1
#define google_protobuf_FileOptions_java_outer_classname_tag 8
#define google_protobuf_FileOptions_java_multiple_files_tag 10
#define google_protobuf_FileOptions_java_generate_equals_and_hash_tag 20
#define google_protobuf_FileOptions_java_string_check_utf8_tag 27
#define google_protobuf_FileOptions_optimize_for_tag 9
#define google_protobuf_FileOptions_go_package_tag 11
#define google_protobuf_FileOptions_cc_generic_services_tag 16
#define google_protobuf_FileOptions_java_generic_services_tag 17
#define google_protobuf_FileOptions_py_generic_services_tag 18
#define google_protobuf_FileOptions_php_generic_services_tag 42
#define google_protobuf_FileOptions_deprecated_tag 23
#define google_protobuf_FileOptions_cc_enable_arenas_tag 31
#define google_protobuf_FileOptions_objc_class_prefix_tag 36
#define google_protobuf_FileOptions_csharp_namespace_tag 37
#define google_protobuf_FileOptions_swift_prefix_tag 39
#define google_protobuf_FileOptions_php_class_prefix_tag 40
#define google_protobuf_FileOptions_php_namespace_tag 41
#define google_protobuf_FileOptions_php_metadata_namespace_tag 44
#define google_protobuf_FileOptions_ruby_package_tag 45
#define google_protobuf_FileOptions_uninterpreted_option_tag 999
#define google_protobuf_GeneratedCodeInfo_Annotation_path_tag 1
#define google_protobuf_GeneratedCodeInfo_Annotation_source_file_tag 2
#define google_protobuf_GeneratedCodeInfo_Annotation_begin_tag 3
#define google_protobuf_GeneratedCodeInfo_Annotation_end_tag 4
#define google_protobuf_MessageOptions_message_set_wire_format_tag 1
#define google_protobuf_MessageOptions_no_standard_descriptor_accessor_tag 2
#define google_protobuf_MessageOptions_deprecated_tag 3
#define google_protobuf_MessageOptions_map_entry_tag 7
#define google_protobuf_MessageOptions_uninterpreted_option_tag 999
#define google_protobuf_MethodOptions_deprecated_tag 33
#define google_protobuf_MethodOptions_idempotency_level_tag 34
#define google_protobuf_MethodOptions_uninterpreted_option_tag 999
#define google_protobuf_OneofDescriptorProto_name_tag 1
#define google_protobuf_OneofDescriptorProto_options_tag 2
#define google_protobuf_ServiceOptions_deprecated_tag 33
#define google_protobuf_ServiceOptions_uninterpreted_option_tag 999
#define google_protobuf_UninterpretedOption_name_tag 2
#define google_protobuf_UninterpretedOption_identifier_value_tag 3
#define google_protobuf_UninterpretedOption_positive_int_value_tag 4
#define google_protobuf_UninterpretedOption_negative_int_value_tag 5
#define google_protobuf_UninterpretedOption_double_value_tag 6
#define google_protobuf_UninterpretedOption_string_value_tag 7
#define google_protobuf_UninterpretedOption_aggregate_value_tag 8
#define google_protobuf_UninterpretedOption_NamePart_name_part_tag 1
#define google_protobuf_UninterpretedOption_NamePart_is_extension_tag 2
#define google_protobuf_DescriptorProto_name_tag 1
#define google_protobuf_DescriptorProto_field_tag 2
#define google_protobuf_DescriptorProto_extension_tag 6
#define google_protobuf_DescriptorProto_nested_type_tag 3
#define google_protobuf_DescriptorProto_enum_type_tag 4
#define google_protobuf_DescriptorProto_extension_range_tag 5
#define google_protobuf_DescriptorProto_oneof_decl_tag 8
#define google_protobuf_DescriptorProto_options_tag 7
#define google_protobuf_DescriptorProto_reserved_range_tag 9
#define google_protobuf_DescriptorProto_reserved_name_tag 10
#define google_protobuf_EnumDescriptorProto_name_tag 1
#define google_protobuf_EnumDescriptorProto_value_tag 2
#define google_protobuf_EnumDescriptorProto_options_tag 3
#define google_protobuf_EnumDescriptorProto_reserved_range_tag 4
#define google_protobuf_EnumDescriptorProto_reserved_name_tag 5
#define google_protobuf_EnumValueDescriptorProto_name_tag 1
#define google_protobuf_EnumValueDescriptorProto_number_tag 2
#define google_protobuf_EnumValueDescriptorProto_options_tag 3
#define google_protobuf_FieldDescriptorProto_name_tag 1
#define google_protobuf_FieldDescriptorProto_number_tag 3
#define google_protobuf_FieldDescriptorProto_label_tag 4
#define google_protobuf_FieldDescriptorProto_type_tag 5
#define google_protobuf_FieldDescriptorProto_type_name_tag 6
#define google_protobuf_FieldDescriptorProto_extendee_tag 2
#define google_protobuf_FieldDescriptorProto_default_value_tag 7
#define google_protobuf_FieldDescriptorProto_oneof_index_tag 9
#define google_protobuf_FieldDescriptorProto_json_name_tag 10
#define google_protobuf_FieldDescriptorProto_options_tag 8
#define google_protobuf_FileDescriptorProto_name_tag 1
#define google_protobuf_FileDescriptorProto_package_tag 2
#define google_protobuf_FileDescriptorProto_dependency_tag 3
#define google_protobuf_FileDescriptorProto_public_dependency_tag 10
#define google_protobuf_FileDescriptorProto_weak_dependency_tag 11
#define google_protobuf_FileDescriptorProto_message_type_tag 4
#define google_protobuf_FileDescriptorProto_enum_type_tag 5
#define google_protobuf_FileDescriptorProto_service_tag 6
#define google_protobuf_FileDescriptorProto_extension_tag 7
#define google_protobuf_FileDescriptorProto_options_tag 8
#define google_protobuf_FileDescriptorProto_source_code_info_tag 9
#define google_protobuf_FileDescriptorProto_syntax_tag 12
#define google_protobuf_MethodDescriptorProto_name_tag 1
#define google_protobuf_MethodDescriptorProto_input_type_tag 2
#define google_protobuf_MethodDescriptorProto_output_type_tag 3
#define google_protobuf_MethodDescriptorProto_options_tag 4
#define google_protobuf_MethodDescriptorProto_client_streaming_tag 5
#define google_protobuf_MethodDescriptorProto_server_streaming_tag 6
#define google_protobuf_ServiceDescriptorProto_name_tag 1
#define google_protobuf_ServiceDescriptorProto_method_tag 2
#define google_protobuf_ServiceDescriptorProto_options_tag 3

/* Struct field encoding specification for nanopb */
extern const pb_field_t google_protobuf_FileDescriptorSet_fields[2];
extern const pb_field_t google_protobuf_FileDescriptorProto_fields[13];
extern const pb_field_t google_protobuf_DescriptorProto_fields[11];
extern const pb_field_t google_protobuf_DescriptorProto_ExtensionRange_fields[4];
extern const pb_field_t google_protobuf_DescriptorProto_ReservedRange_fields[3];
extern const pb_field_t google_protobuf_ExtensionRangeOptions_fields[3];
extern const pb_field_t google_protobuf_FieldDescriptorProto_fields[11];
extern const pb_field_t google_protobuf_OneofDescriptorProto_fields[3];
extern const pb_field_t google_protobuf_EnumDescriptorProto_fields[6];
extern const pb_field_t google_protobuf_EnumDescriptorProto_EnumReservedRange_fields[3];
extern const pb_field_t google_protobuf_EnumValueDescriptorProto_fields[4];
extern const pb_field_t google_protobuf_ServiceDescriptorProto_fields[4];
extern const pb_field_t google_protobuf_MethodDescriptorProto_fields[7];
extern const pb_field_t google_protobuf_FileOptions_fields[23];
extern const pb_field_t google_protobuf_MessageOptions_fields[7];
extern const pb_field_t google_protobuf_FieldOptions_fields[9];
extern const pb_field_t google_protobuf_OneofOptions_fields[3];
extern const pb_field_t google_protobuf_EnumOptions_fields[5];
extern const pb_field_t google_protobuf_EnumValueOptions_fields[4];
extern const pb_field_t google_protobuf_ServiceOptions_fields[4];
extern const pb_field_t google_protobuf_MethodOptions_fields[5];
extern const pb_field_t google_protobuf_UninterpretedOption_fields[8];
extern const pb_field_t google_protobuf_UninterpretedOption_NamePart_fields[3];
extern const pb_field_t google_protobuf_SourceCodeInfo_fields[2];
extern const pb_field_t google_protobuf_SourceCodeInfo_Location_fields[6];
extern const pb_field_t google_protobuf_GeneratedCodeInfo_fields[2];
extern const pb_field_t google_protobuf_GeneratedCodeInfo_Annotation_fields[5];

/* Maximum encoded size of messages (where known) */
/* google_protobuf_FileDescriptorSet_size depends on runtime parameters */
/* google_protobuf_FileDescriptorProto_size depends on runtime parameters */
/* google_protobuf_DescriptorProto_size depends on runtime parameters */
/* google_protobuf_DescriptorProto_ExtensionRange_size depends on runtime parameters */
#define google_protobuf_DescriptorProto_ReservedRange_size 22
/* google_protobuf_ExtensionRangeOptions_size depends on runtime parameters */
/* google_protobuf_FieldDescriptorProto_size depends on runtime parameters */
/* google_protobuf_OneofDescriptorProto_size depends on runtime parameters */
/* google_protobuf_EnumDescriptorProto_size depends on runtime parameters */
#define google_protobuf_EnumDescriptorProto_EnumReservedRange_size 22
/* google_protobuf_EnumValueDescriptorProto_size depends on runtime parameters */
/* google_protobuf_ServiceDescriptorProto_size depends on runtime parameters */
/* google_protobuf_MethodDescriptorProto_size depends on runtime parameters */
/* google_protobuf_FileOptions_size depends on runtime parameters */
/* google_protobuf_MessageOptions_size depends on runtime parameters */
/* google_protobuf_FieldOptions_size depends on runtime parameters */
/* google_protobuf_OneofOptions_size depends on runtime parameters */
/* google_protobuf_EnumOptions_size depends on runtime parameters */
/* google_protobuf_EnumValueOptions_size depends on runtime parameters */
/* google_protobuf_ServiceOptions_size depends on runtime parameters */
/* google_protobuf_MethodOptions_size depends on runtime parameters */
/* google_protobuf_UninterpretedOption_size depends on runtime parameters */
/* google_protobuf_UninterpretedOption_NamePart_size depends on runtime parameters */
/* google_protobuf_SourceCodeInfo_size depends on runtime parameters */
/* google_protobuf_SourceCodeInfo_Location_size depends on runtime parameters */
/* google_protobuf_GeneratedCodeInfo_size depends on runtime parameters */
/* google_protobuf_GeneratedCodeInfo_Annotation_size depends on runtime parameters */

/* Message IDs (where set with "msgid" option) */
#ifdef PB_MSGID

#define DESCRIPTOR_MESSAGES \


#endif

#ifdef __cplusplus
} /* extern "C" */
#endif
/* @@protoc_insertion_point(eof) */

#endif
